Unit amb1z_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure amb1z(NM :Integer; N :Integer; var AR :Array of Extended;
                var AI :Array of Extended; var LOW :Integer;
                var IGH :Integer; var SCALE :Array of Extended);

implementation

procedure amb1z(NM :Integer; N :Integer; var AR :Array of Extended;
                var AI :Array of Extended; var LOW :Integer;
                var IGH :Integer; var SCALE :Array of Extended);
var
I,IEXC,J,JJ,K,L,M :Integer;
B2,C,F,G,R,RADIX,S :Extended;
NOCONV :Boolean;
const
SYS063 :Extended = 2.0e0;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230;
begin
{      RADIX - OCHOBAHE CCTEM CCEH,COYEMO }
{      B APMETKE C ABAE ATO HA AHHO MAHE }
RADIX  := SYS063;
B2  := RADIX*RADIX;
K  := 1;
L  := N;
goto _60;
{      PEBAPTEHA EPECTAHOBKA CTPOK  CTOOB }
_10:
SCALE[M-1] := J;
if ( J  =  M ) 
 then goto _40;
for I:=1 to L do
 begin
  F  := AR[(I-1)+(J-1)*NM];
  AR[(I-1)+(J-1)*NM] := AR[(I-1)+(M-1)*NM];
  AR[(I-1)+(M-1)*NM] := F;
  F  := AI[(I-1)+(J-1)*NM];
  AI[(I-1)+(J-1)*NM] := AI[(I-1)+(M-1)*NM];
  AI[(I-1)+(M-1)*NM] := F;
_20:
 end;
for I:=K to N do
 begin
  F  := AR[(J-1)+(I-1)*NM];
  AR[(J-1)+(I-1)*NM] := AR[(M-1)+(I-1)*NM];
  AR[(M-1)+(I-1)*NM] := F;
  F  := AI[(J-1)+(I-1)*NM];
  AI[(J-1)+(I-1)*NM] := AI[(M-1)+(I-1)*NM];
  AI[(M-1)+(I-1)*NM] := F;
_30:
 end;
_40:
case IEXC of
 1: goto _50;
 2: goto _90;
end;
{      OCK CTPOK C OPOBAHHM C.H. HA AOHA }
{       CB X BH }
_50:
if ( L  =  1 ) 
 then goto _230;
L  := L - 1;
{       J = L,1,-1 }
_60:
for JJ:=1 to L do
 begin
  J  := L + 1 - JJ;
  for I:=1 to L do
   begin
    if ( I  =  J ) 
     then goto _70;
    if ( AR[(J-1)+(I-1)*NM] <>  0.0e0  ) or (  AI[(J-1)+(I-1)*NM] <>  0.0e0 )
     then goto _80;
_70:
   end;
  M  := L;
  IEXC  := 1;
  goto _10;
_80:
 end;
goto _100;
{      OCK CTOOB C OP. C.H. HA AOHA }
{       CB X BEBO }
_90:
K  := K + 1;
_100:
for J:=K to L do
 begin
  for I:=K to L do
   begin
    if ( I  =  J ) 
     then goto _110;
    if ( AR[(I-1)+(J-1)*NM] <>  0.0e0  ) or (  AI[(I-1)+(J-1)*NM] <>  0.0e0 )
     then goto _120;
_110:
   end;
  M  := K;
  IEXC  := 2;
  goto _10;
_120:
 end;
{      MAC-E OMATP,PACOOEHHO B CTPOKAX }
{       CTOAX C HOMEPAM OT K O L }
for I:=K to L do
 begin
  SCALE[I-1] := 1.0e0;
_130:
 end;
{      TEPAOHHOE YMEHEHE HOPM }
_140:
NOCONV  := False;
for I:=K to L do
 begin
  C  := 0.0e0;
  R  := 0.0e0;
  for J:=K to L do
   begin
    if ( J  =  I ) 
     then goto _150;
    C  := C + Abs(AR[(J-1)+(I-1)*NM]) + Abs(AI[(J-1)+(I-1)*NM]);
    R  := R + Abs(AR[(I-1)+(J-1)*NM]) + Abs(AI[(I-1)+(J-1)*NM]);
_150:
   end;
{      MEP PEOCTOPOHOCT B CYAE C=.  R=. }
  if ( C  =  0.0e0  ) or (  R  =  0.0e0 ) 
   then goto _220;
  G  := R/RADIX;
  F  := 1.0e0;
  S  := C + R;
_160:
  if ( C  >=  G ) 
   then goto _170;
  F  := F*RADIX;
  C  := C*B2;
  goto _160;
_170:
  G  := R*RADIX;
_180:
  if ( C  <  G ) 
   then goto _190;
  F  := F/RADIX;
  C  := C/B2;
  goto _180;
{      NOW BALANCE }
_190:
  if ( (C + R)/F  >=  0.95e0*S ) 
   then goto _220;
  G  := 1.0e0/F;
  SCALE[I-1] := SCALE[I-1]*F;
  NOCONV  := True;
  for J:=K to N do
   begin
    AR[(I-1)+(J-1)*NM] := AR[(I-1)+(J-1)*NM]*G;
    AI[(I-1)+(J-1)*NM] := AI[(I-1)+(J-1)*NM]*G;
_200:
   end;
  for J:=1 to L do
   begin
    AR[(J-1)+(I-1)*NM] := AR[(J-1)+(I-1)*NM]*F;
    AI[(J-1)+(I-1)*NM] := AI[(J-1)+(I-1)*NM]*F;
_210:
   end;
_220:
 end;
if ( NOCONV ) 
 then goto _140;
_230:
LOW  := K;
IGH  := L;
end;

end.
